var gulp = require('gulp')
var series = require('run-sequence').use(gulp)
var task = require('./lib/task')
var vars = require('./lib/gen-vars')
var config = require('./lib/config')

var build = function (opts) {
  return function () {
    return task.build(Object.assign(opts, { message: 'build boncloud theme' }))
  }
}

var buildBoncloud = function (opts) {
  return function () {
    return task.buildBoncloud(Object.assign(opts, { message: 'build boncloud theme' }))
  }
}

var fonts = function (opts) {
  return function () {
    return task.fonts(Object.assign(opts, { message: 'build theme font' }))
  }
}

exports.init = function (filePath) {
  filePath = {}.toString.call(filePath) === '[object String]' ? filePath : ''
  vars.init(filePath)
}

exports.watch = function (opts) {
  gulp.task('build', build(opts))
  gulp.task('buildBoncloud', buildBoncloud(opts))
  exports.run(opts)
  gulp.watch(opts.config || config.config, ['build', 'buildBoncloud'])
}

exports.run = function (opts, cb) {
  gulp.task('build', build(opts))
  gulp.task('buildBoncloud', buildBoncloud(opts))
  gulp.task('fonts', fonts(opts))
  if (typeof cb === 'function') {
    return series('build', 'buildBoncloud', 'fonts', cb);
  }
  return series('build', 'buildBoncloud', 'fonts');
}
